/*
*********************************************************************************************************
*                                               uC/OS-II
*                                        The Real-Time Kernel
*
*                        (c) Copyright 1992-1998, Jean J. Labrosse, Plantation, FL
*                                          All Rights Reserved
*
*                                       Keil C51 6.20c specific code
*                                          LARGE MEMORY MODEL
*
* File : OS_CPU.H
* By   : Jean J. Labrosse
*
* Modified by: JohnBlue 2001/11/28
*********************************************************************************************************
*/

#ifndef __OS_CPU_H
#define __OS_CPU_H

#ifdef  OS_CPU_GLOBALS
#define OS_CPU_EXT
#else
#define OS_CPU_EXT  extern
#endif

/*
*********************************************************************************************************
*                                              DATA TYPES
*                                         (Compiler Specific)
*********************************************************************************************************
*/

typedef unsigned char  BOOLEAN;
typedef unsigned char  INT8U;                    /* Unsigned  8 bit quantity                           */
typedef signed   char  INT8S;                    /* Signed    8 bit quantity                           */
typedef unsigned int   INT16U;                   /* Unsigned 16 bit quantity                           */
typedef signed   int   INT16S;                   /* Signed   16 bit quantity                           */
typedef unsigned long  INT32U;                   /* Unsigned 32 bit quantity                           */
typedef signed   long  INT32S;                   /* Signed   32 bit quantity                           */
typedef float          FP32;                     /* Single precision floating point                    */

typedef unsigned char  OS_STK;                   /* Each stack entry is 8-bit wide                    */

#define BYTE           INT8S                     /* Define data types for backward compatibility ...   */
#define UBYTE          INT8U                     /* ... to uC/OS V1.xx.  Not actually needed for ...   */
#define WORD           INT16S                    /* ... uC/OS-II.                                      */
#define UWORD          INT16U
#define LONG           INT32S
#define ULONG          INT32U

/* 
*********************************************************************************************************
*                              Keil C51 on generic 8051-based microcontroller
*********************************************************************************************************
*/

#define  OS_ENTER_CRITICAL()  EA=0		    		/* Disable interrupts                            */
#define  OS_EXIT_CRITICAL()   EA=1			 		/* Enable  interrupts                            */
#define  OS_STK_GROWTH        1                     /* Stack grows from HIGH to LOW memory on for large mode */
#define  OS_TASK_SW()         OSCtxSw()

extern unsigned char data OSTickRate;


#endif
